import { EventEmitter } from "eventemitter3";
import { Event } from "./Event";
import { Connection, Repository as TypeORMRepository } from "typeorm";
interface RepositoryOptions {
    indices: string[];
    forceSnapshot: boolean;
    snapshotFrequency: number;
}
export declare class Repository extends EventEmitter {
    EntityType: any;
    connection: Connection;
    forceSnapshot: boolean;
    indices: string[];
    options: RepositoryOptions;
    snapshotFrequency: number;
    events: TypeORMRepository<Event>;
    constructor(EntityType: any, options?: {
        indices: any[];
        forceSnapshot: boolean;
        snapshotFrequency: number;
    });
    commit(entity: any, options?: {
        forceSnapshot: boolean;
    }): Promise<any>;
    get(id: any): Promise<any>;
    _getByIndex(index: any, value: any): Promise<any>;
    _commitEvents(entity: any, options?: any): Promise<any>;
    _deserialize(id: any, snapshot: any, events: any): any;
    _emitEvents(entity: any): void;
}
export {};
